/*TITLE vector definition */

/****keyword-flag*** "%v %f %n" */
/* "1 7-May-96,19:20:26 VECTOR.H" */

/****revision-history****/
/*1 VECTOR.H 7-May-96,19:20:26 As of MAINPT.                                  */
/****revision-history****/

#ifndef VECTOR_H
#define VECTOR_H

#include "common.h"
#include "wassert.h"
typedef unsigned short ArrayIndex;


template <class T>
class vector
{
protected:
    T *m_Data;
    ArrayIndex m_Count;
public:
    vector();
    vector(ArrayIndex p_Count);
    vector(ArrayIndex p_Count, T *p_Data);
    vector(const vector& p_Vector);
short operator == (const vector& p_Vector);
void *GetDataAddress(){return (void *)m_Data;}
vector& operator = (const vector& p_Vector);

T& operator [] (ArrayIndex p_ArrayIndex)
{
vectorassert (p_ArrayIndex, m_Count);
return m_Data[p_ArrayIndex];
}
ArrayIndex GetSize() {return m_Count;}
void	SetSize(ArrayIndex p_NewCount);
    ~vector() {delete [] m_Data;}
};

template <class T>
vector<T>::vector()
{
    m_Data = new T[0];
    m_Count = 0;
};

template <class T>
vector<T>::vector(ArrayIndex p_Count)
{
    m_Data = new T[p_Count];
    m_Count = p_Count;
    for (ArrayIndex i = 0; i < m_Count; i ++)
        m_Data[i] = T();
};

template <class T>
vector<T>::vector(ArrayIndex p_Count, T *p_Data)
{
    m_Data = new T[p_Count];
    m_Count = p_Count;
    for (ArrayIndex i = 0; i < m_Count; i ++)
        m_Data[i] = p_Data[i];
};

template <class T>
vector<T>::vector(const vector<T>& p_Vector)
{
    if (this == &p_Vector)
        return;

    m_Count = p_Vector.m_Count;
    m_Data = new T[m_Count];
    for (ArrayIndex i = 0; i < m_Count; i ++)
        m_Data[i] = p_Vector.m_Data[i];
};


template <class T>
vector<T>& vector<T>::operator = (const vector<T>& p_Vector)
{
    if (this == &p_Vector)
        return *this;

    delete [] m_Data;
    m_Count = p_Vector.m_Count;
    m_Data = new T[m_Count];
    for (ArrayIndex i = 0; i < m_Count; i ++)
        m_Data[i] = p_Vector.m_Data[i];
    return *this;
};


template <class T>
short vector<T>::operator == (const vector<T>& p_Vector)
{
    if (this == &p_Vector)
        return 1;
    if (m_Count != p_Vector.m_Count)
        return 0;
    if (m_Count == 0)
        return 1;
    if (memcmp(m_Data,p_Vector.m_Data,m_Count*sizeof(T)) == 0)
        return 1;
    return 0;
};


template <class T>
void vector<T>::SetSize(ArrayIndex p_NewCount)
{
    T *TempPtr;
    ArrayIndex i;
    ArrayIndex Smaller;

    Smaller = min(p_NewCount, m_Count);

    TempPtr = new T[p_NewCount];
    for (i = 0; i < Smaller; i ++)
        TempPtr[i] = m_Data[i];

    delete [] m_Data;
    m_Count = p_NewCount;
    m_Data = TempPtr;
};

#endif
